#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<int>> graph(n + 1); //     

    //  
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    set<int> guardedWarehouses; //     

    //  
    for (int i = 0; i < k; ++i) {
        int p, h;
        cin >> p >> h;

        // BFS    
        vector<bool> visited(n + 1, false);
        queue<pair<int, int>> q; //  ( , )
        q.push({p, 0});
        visited[p] = true;

        while (!q.empty()) {
            auto [currentWarehouse, distance] = q.front();
            q.pop();

            //     , 
            if (distance > h) continue;

            guardedWarehouses.insert(currentWarehouse); //    

            //   
            for (int neighbor : graph[currentWarehouse]) {
                if (!visited[neighbor]) {
                    visited[neighbor] = true;
                    q.push({neighbor, distance + 1});
                }
            }
        }
    }

    //  
    cout << guardedWarehouses.size() << endl;
    if (!guardedWarehouses.empty()) {
        vector<int> result(guardedWarehouses.begin(), guardedWarehouses.end());
        sort(result.begin(), result.end());
        for (int warehouse : result) {
            cout << warehouse << " ";
        }
        cout << endl;
    } else {
        cout << endl; //  ,    
    }

    return 0;
}
